#include <pic.h>
//pic16f628a

__CONFIG (INTIO & UNPROTECT & LVPDIS & BOREN & MCLRDIS & PWRTEN & WDTDIS);

void podgot (void); //  
void read_all (void); //   
void ind_ent (void); //     
void lm7001_tx (void); //     LM
void ind_pict (void); //    
void encoder (void); //  
void work (void); //  


// ===  
void main (void){
podgot ();  //  
read_all (); //   
ind_ent (); //     
lm7001_tx (); //     LM
while(1) //   
{
work ();
} //   
} //  


// ===  
void podgot (void)
{INTCON = 0;  //   
TRISA = 0b01000000; TRISB = 0b00011000;
PORTA = 0; PORTB = 0; 
//   1
PEIE   = 1;  //   
T1CKPS0 = 0; // T1CON 
T1CKPS1 = 0; //   
T1OSCEN = 0; //   
TMR1CS  = 0; //     
TMR1ON  = 1; //   tmr1
CCP1CON = 0; //   
TMR1IE  = 1; //     tmr1
//  
RBIE   = 1;  //    RB4:RB7 (1-, 0-)
RBIF   = 0;  //      RB4:RB7
//  
GIE    = 1;	 //  
}

void mode_key (void); //   
void mode_enc (void); //  

// ===  
void work (void){
mode_key (); //   
mode_enc (); //  
}

void freq_max (void); //  
void freq_min (void); //  
void ind_ent (void); //     
void lm7001_tx (void); //     LM

// ====================================
// ===    ===
// ====================================
unsigned char key_rez; //    
unsigned char chan; //  
void read_chan (void); //     

void mode_key (void){
unsigned int tmp;
if (key_rez != 0)
{ //    
if (key_rez == 6){chan = 1; read_chan ();}
if (key_rez == 7){chan = 2; read_chan ();}
if (key_rez == 8){chan = 3; read_chan ();}
if (key_rez == 1){chan = 4; read_chan ();}
if (key_rez == 2){chan = 5; read_chan ();}
if (key_rez == 3){chan = 6; read_chan ();}
if (key_rez == 4)freq_min();
if (key_rez == 5)freq_max();
ind_ent(); //     
lm7001_tx(); //     LM
} //    
} //  


// ==========================
// ===   ===
// ==========================
bit enc_napr;  //  : 1-, 0-
bit enc_act;   //  : 1-, 0- 

void mode_enc (void){
if (enc_act == 1){
if (enc_napr == 1) freq_min();
if (enc_napr == 0) freq_max();
enc_act = 0;
ind_ent(); //     
lm7001_tx(); //     LM
}
}


// ==================================
// ===    ===
// ==================================
unsigned int  freq; //   
void write_all (void); //  

// ===  
void freq_max (void){
freq=freq+5; 
if (freq > 10800) freq = 8800;
write_all(); //  
}

// ===  
void freq_min (void){
freq=freq-5; 
if (freq < 8800) freq = 10800;
write_all(); //  
}


// ========================================
// ===      ===
// ========================================
void decomp (unsigned int x); //    
unsigned char x5, x4, x3, x2, x1; // 0000, 000, 00, 0, 

 unsigned char arr_raz[6]; //      
//      ( )
#define p1 arr_raz[0]
#define p2 arr_raz[1]
#define p3 arr_raz[2]
#define p4 arr_raz[3]

bit bit05; //   

void ind_ent (void){
decomp (freq);
p1=x5; p2=x4; p3=x3; p4=x2;
//   
if (p1 == 0) p1=10; // .. 
if (x1 == 5) bit05=1; else bit05=0;
}

// ==============================
// ===   ===
// ==============================
//   
#define r1 RA2
#define r2 RA3
#define r3 RB1
#define r4 RB2

#define dat RA7 //     hc595
#define out RA0 //    hc595
#define str RA1 //   hc595

void key (void); //   ( )

//      
unsigned char arr_raz[6]={1,2,3,4};

//     7-  
const unsigned char arr_seg[11]={
//  0bABCDEFGH
	0b11111100,	// 0
	0b01100000, // 1
	0b11011010, // 2
	0b11110010, // 3
	0b01100110, // 4
	0b10110110, // 5
	0b10111110, // 6
	0b11100000, // 7
	0b11111110, // 8
	0b11110110, // 9
	0b00000000, //   - 10 - 
};


//      
#define A seg.biit.b7
#define B seg.biit.b6
#define C seg.biit.b5
#define D seg.biit.b4
#define E seg.biit.b3
#define F seg.biit.b2
#define G seg.biit.b1
#define H seg.biit.b0

unsigned char count_raz; //  
void ind_strob (void); //  

// ===    
void ind_pict (void) {
(count_raz > 3) ? count_raz = 0 : count_raz++; 

//   (  )
dat = 1 - A; ind_strob();
dat = 1 - F; ind_strob();
dat = 1 - B; ind_strob();
dat = 1 - G; ind_strob();
dat = 1 - C; ind_strob();
dat = 1 - H; ind_strob();
dat = 1 - D; ind_strob();
dat = 1 - E; ind_strob();

//  
switch (count_raz){
case 0: r4 = 1; r1 = 0; break;
case 1: r1 = 1; r2 = 0; break;
case 2: r2 = 1; r3 = 0; break;
case 3: r3 = 1; r4 = 0; break;
case 4:
r4 = 1;
key (); //   ( )
break;
}
//  
out=1; out=0;
}

// === 
void ind_strob (void) 
{str=1; str=0;}


// ========================
// ===   ===
// ========================
#define key_in RA6
unsigned char key_rez; //    

void key (void){ //   
unsigned char tmp;

//   
key_rez = 0; //  
dat = 0; //  
for (tmp=1; tmp<9; tmp++){
ind_strob();
out=1; out=0;
if (key_in == 0) key_rez = tmp;
dat = 1; //    
}
} //  



// ==========================
// ===  LM7001J ===
// ==========================
#define DA_LM RB7
#define CL_LM RB6
#define CE_LM RB5

void lm_strob (void); //  LM7001

void lm7001_tx (void)
{unsigned long int tmp;
//   
lm.biit.T0=0;
lm.biit.T1=0;
lm.biit.B0=0; // B01(pin7) / 8Hz
lm.biit.B1=0; // B02(pin8)
lm.biit.B2=0; // B03(pin9)
lm.biit.TB=0;
lm.biit.R0=0;
lm.biit.R1=0; 
lm.biit.R2=1; // 50KHz
lm.biit.S =1; // (FM=1 AM=0)
//    
tmp = (freq - 1070);
tmp = (tmp*1440)/4000;
lm.byte = tmp;
//    3-    LM7001
CE_LM = 1; // Chip Enabled = On
DA_LM = lm.biit.D0;  lm_strob();
DA_LM = lm.biit.D1;  lm_strob();
DA_LM = lm.biit.D2;  lm_strob();
DA_LM = lm.biit.D3;  lm_strob();
DA_LM = lm.biit.D4;  lm_strob();
DA_LM = lm.biit.D5;  lm_strob();
DA_LM = lm.biit.D6;  lm_strob();
DA_LM = lm.biit.D7;  lm_strob();
DA_LM = lm.biit.D8;  lm_strob();
DA_LM = lm.biit.D9;  lm_strob();
DA_LM = lm.biit.D10; lm_strob();
DA_LM = lm.biit.D11; lm_strob();
DA_LM = lm.biit.D12; lm_strob();
DA_LM = lm.biit.D13; lm_strob();
DA_LM = lm.biit.T0;  lm_strob();
DA_LM = lm.biit.T1;  lm_strob();
DA_LM = lm.biit.B0;  lm_strob();
DA_LM = lm.biit.B1;  lm_strob();
DA_LM = lm.biit.B2;  lm_strob();
DA_LM = lm.biit.TB;  lm_strob();
DA_LM = lm.biit.R0;  lm_strob();
DA_LM = lm.biit.R1;  lm_strob();
DA_LM = lm.biit.R2;  lm_strob();
DA_LM = lm.biit.S;   lm_strob();
CE_LM = 0; // Chip Enabled = Off
}


// ===  LM7001
void lm_strob (void) 
{
asm("nop");
CL_LM=1; 
asm("nop");
CL_LM=0;
}